/**
 * @author v_wangyan
 * @date 2012-11-05
 */ 
var skin = window.skin || {};
/**
 * 获取元素对象
 * @param  {string} element 元素id
 * @return {object}         返回元素对象
 */
skin.g = function(element) {
    return document.getElementById(element) || element;
},
/**
 * 转换JSON对象
 * @param  {string} jsonString json字符串
 * @return {object}            json对象
 */
skin.jsonDecode =function(jsonString) {
	return (new Function("return " + jsonString))();
},
/**
 * 显示dom
 * @param  {string} id dom的id |dom 对象
 * @return {void}    无
 */

skin.show = function(id) {
	skin.isShow(id, true);
},
/**
 * 隐藏dom
 * @param  {string} id dom的id |dom 对象
 * @return {void}    无
 */
skin.hide = function(id) {
    skin.isShow(id, false);
},
/**
 * 是否显示
 * @param  {string} id dom的id |dom 对象
 * @param  {bool} flag 是否显示
 */
skin.isShow = function(element, flag) {
    element = skin.g(element)||element;
    element.style.display = flag ? 'block' : 'none';
},
/**
 * 添加样式
 * @param {string|object} element   目标元素
 * @param {string} className 样式名称
 */
skin.addClass = function(element, className) { 
	element = skin.g(element)||element;
    var classArray = className.split(/\s+/),
        result = element.className,
        classMatch = " " + result + " ",
        i = 0,
        l = classArray.length;

    for (; i < l; i++) {
         if ( classMatch.indexOf( " " + classArray[i] + " " ) < 0 ) {
             result += (result ? ' ' : '') + classArray[i];
         }
    }

    element.className = result;
},
/**
 * 移除样式
 * @param  {string|object} element   目标元素
 * @param  {string} className 样式名称
 * @return {void}           无
 */
skin.removeClass = function(element, className) { 
	element = skin.g(element)||element; 

    var oldClasses = element.className.split(/\s+/),
        newClasses = className.split(/\s+/),
        lenOld,
        lenDel = newClasses.length,
        j,
        i = 0;  
    for (; i < lenDel; ++i) {
        for(j = 0, lenOld = oldClasses.length; j < lenOld; ++j) {
            if (oldClasses[j] == newClasses[i]) {
            	oldClasses.splice(j, 1);
            	break;
            }
        }
    }
    element.className = oldClasses.join(' ');
},
/**
 * 设置字体
 * @param {int}   
 * @return void
 */
skin.setFontFamily = function (key) {   //设置字体:  0-宋体 ; 1-微软雅黑;
    key = key || '0';
    var obj = document.body;
    var font = ''; 
    if (key) {
        font = '"微软雅黑", "宋体", Arial, Verdana';
    } else {
        font = '"宋体", "微软雅黑", Arial, Verdana';
    }
    obj.style.fontFamily = font;
}
/**
 * 设置页面显示的字体(win7--雅黑字,其他为宋体)
 * @param 无
 * @return string
 */
skin.getSysver = function () {
    var key = 0;
    try {
        key = execOrder('sysver');
        if ('6.1' == key) {
            key = 1;
        }
    } catch (e) {   }   
    
    skin.setFontFamily(key); 
}
/**
 * 处理icon点击
 * @param  {event} e          事件
 * @param  {bool} rightClick 是否为右键(点击)
 * @param  {number} key        iconid
 * @return {void}            无
 */
skin.execMouseDown = function (e, rightClick, key) {
    //取消冒泡事件
    e.stopPropagation(); 
    
    var order = rightClick ? 'mouseRDown' : 'mouseLDown';
    try {
        window.external.SyncRequest(order, key);
    } catch (e) {}  
},
/**
 * 处理右键点击
 * @param  {string} id elementid
 * @return {void}    无
 */
skin.rightButton = function (id) {
    if (event.button == 2) {
       skin.execMouseDown(event, true, id);
    }
},
/**
 * 执行命令
 * @param {string} 命令名称
 * @param {string} 值
 * @return string | void
 */
skin.execOrder = function (order, key) {
    var info = '';
    try { 
        key = (key.length == 0 ? '0' : key); 
        info = window.external.SyncRequest(order, key);
    } catch (e) {       
    } 
    return info;
},
/**
 * 执行客户端命令,获取参数
 * @param  {string} order 命令名称
 * @param  {string} param 参数
 * @return {void|object}       无|-
 */
skin.execSync = function (order, param) {
    try {
        if (window.external.SyncRequest) {
            return window.external.SyncRequest(order, param);
        } 
    } catch (e) {
        return '';
    }
    return '';
},
/**
 * 设置本地存储--(使用)获取到对应参数值,进行赋值后重新存储该值
 * @type {Object}
 */
skin.storage = {
    set: function (key, value) {
        this.data(key, value);
    },
    get: function (key) {  
        return this.data(key);
    },
    /**
     * 处理存储数据
     * @param  {string} key   存储(获取的)key
     * @param  {[type]} value 存储的值
     * @return {boolea | object}       操作结果
     */
    data: function (key, value) { 
        var configData = skin.execSync('readConfig') || '{}'; 
        if (typeof configData  == 'string') {
            configData = JSON.parse(configData);
        }         
        if (value) {     
            configData[key] = value;
            skin.execSync('saveConfig', JSON.stringify(configData));            
            return true;
        } else {                                 
            return (key ? (configData[key] || false) : configData);
        }
        return false;
    }
},
//获取RD数据status,null 时返回当前状态
/**
 * 设置icon状态
 * @param  {string} id  icon的id
 * @param  {string} key 命令
 * @return {void}     无
 */
skin.getExecStatus = function (id, key) {  
    if (typeof skin.g(id) == 'string') {
        return;
    }
    var statu = skin.execSync('getButtonState', key) || skin.g(id).getAttribute('statu'); 
    return statu;
},
/**
 * 初始输入法状态  
 * 参数:0 (中英文切换) 返回值: 0 英文 1 中文;
 * 参数:1 (全半角切换) 返回值: 0 半角 1 全角; 
 * 参数:2 (中英文标点) 返回值: 0 英文标点 1 中文标点;
 * 参数:3 (软键盘)
 * 参数:4 (登录)            返回值: 0 未登录 1 已登录
 * 参数:5 (配置)
 */
skin.setIMEStatus = function () { 
    setButtonState('0', skin.getExecStatus('language', '0'));   
    setButtonState('2', skin.getExecStatus('punctuation', '2'));  
},
/**
 * 绑定输入法icon点击/hover等事件
 * @return {void} 无
 */
skin.bindEvent = function () {
    var icons = skin.g('box').getElementsByTagName('p'); 
    for (var i = 0, len = icons.length; i < len; i++) {   
        icons[i].onclick = function () { 
            skin.execMouseDown(event, false, this.getAttribute('key'));
        }
        icons[i].onmouseup = function () { 
            skin.rightButton(this.getAttribute('key'));          
        }
    }
    document.onclick  =function () {
        skin.execMouseDown(event, false, 'null');    
    }    
    document.onmouseup =function () {  
        skin.rightButton('null'); 
    }
},
/**
 * 打开链接
 * @param  {object} obj 触发元素
 * @return {void}     无
 */
skin.proccessOpenUrl = function (obj) {
    skin.execOrder('openURL', obj.getAttribute('link'));
},
/**
 * 处理各种映射事件
 */
skin.proccessEvent = function () {
    document.body.onmouseup = function (e) {
        var element = e.target,
            eventType = element.getAttribute('event-type');
        if (e.button == 0) { 
            var fnName = config.eventMap[eventType];  
            if (typeof window.skin[fnName] == 'function') { 
                window.skin[fnName](element, eventType);
            }
        }
    }
},
/**
 * 处理监听事件
 * @param  {string} eventName 监听类型
 */
skin.playerEventListener = function (eventName) {
    skin.player.addEventListener(eventName, function(){
        if(eventName == 'ended') { 
            skin.proccessChangeMusic(null, 'next');
        } 
    });
},
/**
 * 切换歌曲
 * @param  {object} element   上一首|下一首按钮
 * @param  {string} eventType prev|next
 */
skin.proccessChangeMusic = function (element, eventType) {
    var c = eventType == 'prev' ? -1 : 1;
    skin.playIndex = skin.playIndex + c;
    if (skin.playIndex < 0) {
        skin.playIndex = skin.playTotal - 1;
    } else if (skin.playIndex >= skin.playTotal) {
        skin.playIndex = 0;
    }
    skin.replay(skin.playIndex);
},
/**
 * 开始播放
 * @param  {object} element   dom对象,开始按钮
 * @param  {string} eventType play
 */
skin.proccessPlayMusic = function (element, eventType) {
    skin.setPlayer(element, true);
    skin.player.play();
},
/**
 * 暂停播放
 * @param  {object} element   dom对象,暂停按钮
 * @param  {string} eventType pause
 */
skin.proccessPauseMusic = function (element, eventType) {
    skin.setPlayer(element, false);
    skin.player.pause();
},
/**
 * 重置播放
 * @param  {number} k 歌曲索引
 */
skin.replay= function (k) {
    try {
        skin.player.currentTime = 0; 
    } catch (e) {}
    skin.player.setAttribute('src', config.playUrl + config.playList[k]);
    skin.setPlayer(skin.g('showPlayer'), true);
    skin.player.play();
},
/**
 * 设置播放器
 * @param {bool} play (true 播放| false 暂停)
 */
skin.setPlayer = function (element, play) {
    if (play) {
        skin.addClass(element, 'pause');
        element.setAttribute('event-type', 'pause');
    } else {
        skin.removeClass(element, 'pause');
        element.setAttribute('event-type', 'play');
    }
},
/**
 * 设置皮肤初始状态
 */
skin.initSkin = function () { 
    // 设置字体显示
    skin.getSysver();  
    // 初始化icon状态
    skin.setIMEStatus(); 
    // 绑定icon事件
    skin.bindEvent();
    // 映射事件
    skin.proccessEvent();

    skin.player = skin.g('mp3Player');
    skin.playIndex = 0;
    skin.playTotal = config.playList.length;
    skin.replay(skin.playIndex);
    skin.playerEventListener('ended');
    skin.playerEventListener('pause');
    skin.playerEventListener('play');
},
/**
 * 设置皮肤动画
 */
skin.setAnimate = function () {

};
// 供客户端调用
function setButtonState(key, statu) { 
    var status = config.buttonstatus;
    var id = '';
    key = key || '0';
    id = status[key].id;
    if (typeof skin.g(id) == 'string') {
        return;
    }
    statu =  statu || (skin.g(id).getAttribute('statu') == '0' ? '1' : '0');     
    skin.g(id).style.backgroundImage = 'url(images/icons/' + status[key][statu] + ')';
    skin.g(id).setAttribute ('statu', statu);        
}
/**
 * 在一支笔中打印日志
 * @param {string} str 打印的内容
 */
function Log(str) {   
    try {
        if(window.external.SyncRequest) { 
            window.external.SyncRequest('log', str);
        } else {   //在浏览器控制台中输出        
            console.log(str);
        }
    } catch (e) {}
}


